function varargout = gui_speech_analysis(varargin)
% GUI_SPEECH_ANALYSIS MATLAB code for gui_speech_analysis.fig
%      GUI_SPEECH_ANALYSIS, by itself, creates a new GUI_SPEECH_ANALYSIS or raises the existing
%      singleton*.
%
%      H = GUI_SPEECH_ANALYSIS returns the handle to a new GUI_SPEECH_ANALYSIS or the handle to
%      the existing singleton*.
%
%      GUI_SPEECH_ANALYSIS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI_SPEECH_ANALYSIS.M with the given input arguments.
%
%      GUI_SPEECH_ANALYSIS('Property','Value',...) creates a new GUI_SPEECH_ANALYSIS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before gui_speech_analysis_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to gui_speech_analysis_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help gui_speech_analysis

% Last Modified by GUIDE v2.5 10-Jan-2011 13:29:01

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_speech_analysis_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_speech_analysis_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before gui_speech_analysis is made visible.
function gui_speech_analysis_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to gui_speech_analysis (see VARARGIN)

% Choose default command line output for gui_speech_analysis
handles.output = hObject;

% Update handles structure
global x;
global xfft;
global xfft_half;
global male;
global female;
x = ones(9600,1);
set(hObject, 'toolbar', 'figure');
guidata(hObject, handles);

% UIWAIT makes gui_speech_analysis wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = gui_speech_analysis_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton_plotSignal.
function pushbutton_plotSignal_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_plotSignal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global x;
axes(handles.axes1);
cla;
t = (1:9600)/8000;
plot(t,x);
title('Recorded signal amplitude vs Time');
xlabel('Time in seconds');
ylabel('Amplitude');
if ((sum(x == ones(9600,1))) == 9600)
    %the first, second and third lines of the message box
    msgboxText{1} = 'You have tried to plot a signal without recording one';
    msgboxText{2} = 'Try recording a signal of length 1.2 seconds using ';
    msgboxText{3} = 'the record button';
    %this command actually creates the message box
   msgbox(msgboxText,'Signal recording not done', 'warn');
end
guidata(hObject, handles);


% --- Executes on button press in pushbutton_plotSpectrum.
function pushbutton_plotSpectrum_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_plotSpectrum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global x;
global xfft;
axes(handles.axes1);
cla;
xfft = fftshift(abs(fft(x,8000)));
freq = -3999:4000;
plot(freq,xfft);
title('Spectrum of the recorded signal');
xlabel('Frequency in Hertz');
ylabel('Zero centred fft of recorded signal');
if ((sum(x == ones(9600,1))) == 9600)
    %the first, second and third lines of the message box
    msgboxText{1} = 'You have tried to plot spectrum of a signal without recording one';
    msgboxText{2} = 'Try recording a signal of length 1.2 seconds using ';
    msgboxText{3} = 'the record button';
    %this command actually creates the message box
   msgbox(msgboxText,'Signal recording not done', 'warn');
end
guidata(hObject, handles);


% --- Executes on button press in pushbutton_record.
function pushbutton_record_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_record (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global x;
male = wavrecord(9600,8000);
x = male;
set(handles.gender,'String','See the estimated gender here');
guidata(hObject, handles);


% --- Executes on button press in estimateGender.
function estimateGender_Callback(hObject, eventdata, handles)
% hObject    handle to estimateGender (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global x;
global xfft;
global xfft_half;
global male;
global female;
if ((sum(x == ones(9600,1))) == 9600)
    %the first, second and third lines of the message box
    msgboxText{1} = 'You have tried to estimate gender without recording signal';
    msgboxText{2} = 'Try recording a signal of length 1.2 seconds using ';
    msgboxText{3} = 'the record button';
    %this command actually creates the message box
   msgbox(msgboxText,'Signal recording not done', 'warn');
else
    xfft_half(1:4001) = xfft(4000:8000);
    [ym1,fm1] = max(xfft_half(99:179));
    fm1 = fm1 + 98;
    [ym2,fm2] = max(xfft_half(189:368));
    fm2 = fm2 + 187;
    [ym3,fm3] = max(xfft_half(299:548));
    fm3 = fm3 + 298;
    if abs(fm2-(2*fm1)) <= 8 || abs(fm3 - (3*fm1)) <=8 
        male = 1;
    else
    male = 0;
    end
    [yf1,ff1] = max(xfft_half(179:259));
    ff1 = ff1 + 178;
    [yf2,ff2] = max(xfft_half(369:528));
    ff2 = ff2 + 368;
    [yf3,ff3] = max(xfft_half(539:788));
    ff3 = ff3 + 538;
    if abs(ff2-(2*ff1)) <= 8 || abs(ff3 - (3*ff2))
        female = 1;
    else
        female = 0;
    end
    if male == 1 && female == 0
        set(handles.gender,'String','Male');
    elseif male == 0 && female == 1
        set(handles.gender,'String','Female');
    else
        if ym1>yf1
            set(handles.gender,'String','Male');
        else
            set(handles.gender,'String','Female');
        end
    end
end
